# $Id: qstat.tcl,v 1.3 2003/06/22 12:43:47 peter Exp $

# Einstellungen:

# Flags um die Befehle nutzen zu drfen
set qstat_flag "-|-"

# Pfad zu der qstat binry (unter debian ist es /usr/bin/quakestat) und zu den Speicherdateien
set pathqstatbin "/usr/bin/quakestat"
set savepathqstat "/home/irc/egg/opptest/scripts/qstat"

# Channels wo die Befehle nicht funktionieren sollen.
# (getrennt von Leerzeichen):
set nopub ""

# Ende der Einstellungen



################################################################
# This is where the evil TCL code starts, read at your peril!  #
################################################################

set qversion "2.2_german_by_OppTupacShakur"

bind pub $qstat_flag "!aa"  pub:qstat
bind pub $qstat_flag "!cs"  pub:qstat
bind pub $qstat_flag "!css"  pub:qstat
bind pub $qstat_flag "!cod"  pub:qstat
bind pub $qstat_flag "!doom3"  pub:qstat
bind pub $qstat_flag "!et"  pub:qstat
bind pub $qstat_flag "!gr"  pub:qstat
bind pub $qstat_flag "!gs"  pub:qstat
bind pub $qstat_flag "!gs2"  pub:qstat
bind pub $qstat_flag "!gs3"  pub:qstat
bind pub $qstat_flag "!gs4"  pub:qstat
bind pub $qstat_flag "!hl"  pub:qstat 
bind pub $qstat_flag "!hl2"  pub:qstat 
bind pub $qstat_flag "!mohaa"  pub:qstat 
bind pub $qstat_flag "!qw"  pub:qstat
bind pub $qstat_flag "!q1"  pub:qstat 
bind pub $qstat_flag "!q2"  pub:qstat 
bind pub $qstat_flag "!q3"  pub:qstat 
bind pub $qstat_flag "!q4"  pub:qstat 
bind pub $qstat_flag "!rtcw" pub:qstat
bind pub $qstat_flag "!ut"  pub:qstat
bind pub $qstat_flag "!ut2k3"  pub:qstat
bind pub $qstat_flag "!ut2003" pub:qstat
bind pub $qstat_flag "!ut2004" pub:qstat

bind pub $qstat_flag "!qstat" pub:qstat_help
bind pub $qstat_flag "!help" pub:qstat_help

proc pub:qstat_help {nick host hand chan arg} {
  global pathqstatbin savepathqstat nopub

  if {[lsearch -exact $nopub [string tolower $chan]] >= 0} {return 0}

  putserv "NOTICE $nick :Qstat Befehle:"
  putserv "NOTICE $nick :\002!aa <IP/HOST:PORT>\002 - zeigt den Status von America's Army v2.x Servern."
  putserv "NOTICE $nick :\002!cs <IP/HOST:PORT>\002 - zeigt den Status von CounterStrike/Half-Life Servern."
  putserv "NOTICE $nick :\002!css <IP/HOST:PORT>\002 - zeigt den Status von CounterStrikeSource/Half-Life 2 new Servern."
  putserv "NOTICE $nick :\002!cod <IP/HOST:PORT>\002 - zeigt den Status von Call of Duty Servern."
  putserv "NOTICE $nick :\002!doom3 <IP/HOST:PORT>\002 - zeigt den Status von Doom 3 Servern."
  putserv "NOTICE $nick :\002!et <IP/HOST:PORT>\002 - zeigt den Status von Enemy Territory Servern."
  putserv "NOTICE $nick :\002!gr <IP/HOST:PORT>\002 - zeigt den Status von Ghost Recon Servern."
  putserv "NOTICE $nick :\002!gs <IP/HOST:PORT>\002 - zeigt den Status von Gamespy Protocol Servern."
  putserv "NOTICE $nick :\002!gs2 <IP/HOST:PORT>\002 - zeigt den Status von Gamespy V2 Protocol Servern."
  putserv "NOTICE $nick :\002!gs3 <IP/HOST:PORT>\002 - zeigt den Status von Gamespy V3 Protocol Servern."
  putserv "NOTICE $nick :\002!gs4 <IP/HOST:PORT>\002 - zeigt den Status von Gamespy V4 Protocol Servern."
  putserv "NOTICE $nick :\002!hl <IP/HOST:PORT>\002 - zeigt den Status von CounterStrike/Half-Life Servern."
  putserv "NOTICE $nick :\002!hl2 <IP/HOST:PORT>\002 - zeigt den Status von Half-Life Servern."
  putserv "NOTICE $nick :\002!qw <IP/HOST:PORT>\002 - zeigt den Status von QuakeWorld Servern."
  putserv "NOTICE $nick :\002!q2 <IP/HOST:PORT>\002 - zeigt den Status von Quake II Servern."
  putserv "NOTICE $nick :\002!q3 <IP/HOST:PORT>\002 - zeigt den Status von Quake III Servern."
  putserv "NOTICE $nick :\002!q4 <IP/HOST:PORT>\002 - zeigt den Status von Quake 4 Servern."
  putserv "NOTICE $nick :\002!rtcw <IP/HOST:PORT>\002 - zeigt den Status von Return to Castle Wolfenstein Servern."
  putserv "NOTICE $nick :\002!ut <IP/HOST:PORT>\002 - zeigt den Status von Unreal Servern."
  putserv "NOTICE $nick :\002!ut2k3 <IP/HOST:PORT>\002 - zeigt den Status von Unreal Tournament 2003 Servern."
  putserv "NOTICE $nick :\002!ut2003 <IP/HOST:PORT>\002 - zeigt den Status von Unreal Tournament 2003 Servern."
  putserv "NOTICE $nick :\002!ut2004 <IP/HOST:PORT>\002 - zeigt den Status von UT2004 Servern."

  return 0
}

proc pub:qstat {nick host hand chan arg} {
  global lastbind pathqstatbin savepathqstat nopub

  if {[lsearch -exact $nopub [string tolower $chan]] >= 0} {return 0}

  set arg [lindex $arg 0]

  if {[string length [string trim $arg]] == 0 || [qstat:input_check $arg]} {
    putquick "NOTICE $nick :Syntax: $lastbind <IP/HOST:PORT>"
    return 0
  }

  switch [string tolower $lastbind] {
    "!aa"     { set gametype "-ams";  set players 0 }
    "!cs"     { set gametype "-hls";  set players 0 }
    "!css"     { set gametype "-a2s";  set players 0 }
    "!cod"     { set gametype "-cods";  set players 0 }
    "!doom3"     { set gametype "-dm3s";  set players 0 }
    "!et"     { set gametype "-woets";  set players 0 }
    "!gr"     { set gametype "-grs";  set players 0 }
    "!gs"     { set gametype "-gps";  set players 0 }
    "!gs2"     { set gametype "-gs2";  set players 0 }
    "!gs3"     { set gametype "-gs3";  set players 0 }
    "!gs4"     { set gametype "-gs4";  set players 0 }
    "!hl"     { set gametype "-hls";  set players 0 }
    "!hl2"     { set gametype "-hla2s";  set players 0 }
    "!mohaa"     { set gametype "-mhs";  set players 0 }
    "!qw"     { set gametype "-qws";  set players 0 }
    "!q1"     { set gametype "-qs";   set players 0 }
    "!q2"     { set gametype "-q2s";  set players 0 }
    "!q3"     { set gametype "-q3s";  set players 0 }
    "!q4"     { set gametype "-q4s";  set players 0 }
    "!rtcw"    { set gametype "-rwm";  set players 0 }
    "!ut"     { set gametype "-uns";  set players 0 }
    "!ut2k3"  { set gametype "-ut2s"; set players 0 }
    "!ut2003" { set gametype "-ut2s"; set players 0 }
    "!ut2004" { set gametype "-ut2004s"; set players 0 }
    default {
      putquick "NOTICE $nick :Unbekannter Befehl."
      return 0
    }
  }

  if {$players} { 
    set stat [open "|$pathqstatbin -timeout 5 $gametype $arg -Ts $savepathqstat/server.qstat -Tp $savepathqstat/players.qstat -P" r]
  } else {
    set stat [open "|$pathqstatbin -timeout 5 $gametype $arg -Ts $savepathqstat/server.qstat" r]
  }

  qstat:results $chan $nick $stat

  close $stat
  return 0
}

proc qstat:results {chan nick pf} {
  while {[gets $pf line] >= 0} { 
    if {[string match "DOWN*" $line]} {
      putquick "NOTICE $nick :Connection zurckgewiesen."
      break
    } elseif {[string match "HOSTNOTFOUND*" $line]} {
      putquick "NOTICE $nick :Host wurde nicht gefunden."
      break
    } elseif {[string match "TIMEOUT*" $line]} {
      putquick "NOTICE $nick :Timeout."
      break
    }
    putquick "PRIVMSG $chan :$line"  
  }
}

proc qstat:input_check {text} {
  if {[regexp \[^\[:alnum:\]_\.\:\] $text]} { return 1 }
  if {[string match "0*" $text]} { return 1 }
  return 0
}

putlog "Qstat4Eggdrop version $qversion: geladen!"
